'''ECFresults
'''

from parseECFfile import Event
from os import listdir, getcwd
from os.path import isfile, join


class ResultFolder(object):
    '''Results from folder of ECF submission files for grade calculation.
    '''
    

    def __init__(self, folder=None):

        if folder == None:
            folder = getcwd()

        self.events =  []
        for f in listdir(folder):
            p = join(folder, f)
            if isfile(p):
                self.events.append(Event(p))
                

    def GetPlayers(self):

        players = {}
        for e in self.events:
            for p in e.players:
                if p not in players:
                    players[p] = e.players[p]
        return players
                

    def ProcessAllResults(self, process=None):

        if process == None:
            return

        for e in self.events:
            results = e.results
            for player in results:
                for game in results[player]:
                    opponent, score = game
                    process(player, opponent, score)


if __name__ == '__main__':

    from os.path import abspath


    class Test(object):


        def __init__(self):

            self.i = 0


        def Count(self, player, opponent, score):

            self.i += 1


    a = ResultFolder(abspath('results/Results 2005-2006'))
    c = Test()
    a.ProcessAllResults(c.Count)
    print c.i
    for e in a.events:
        print e.file
