'''parseECFfile
'''

from string import maketrans

table = maketrans('', '')


class Event(object):
    '''Results extracted from an ECF submission file.
    '''
    

    def __init__(self, ECFfile):

        self.file = ECFfile
        self.players = {}
        self.results = {}

        try:
            f = open(ECFfile, 'r')
            try:
                lines = f.read().translate(table, '\r\n').split('#')
            except:
                lines = []
        finally:
            f.close()

        playerlistfound = False
        pinfound = False
        namefound = False
        resultsfound = False
        finishfound = False
        pin1found = False
        pin2found = False
        scorefound = False

        for l in lines:
            e = l.split('=', 1)
            t = e[0]
            if not playerlistfound:
                if t == 'PLAYER LIST':
                    playerlistfound = True
            elif not resultsfound:
                if t == 'PIN':
                    pinfound = True
                    pin = e[-1]
                    bcfcode = ''
                elif t == 'NAME':
                    namefound = True
                    name = e[-1]
                elif t == 'BCF CODE':
                    bcfcode = e[-1]
                elif t == 'OTHER RESULTS':
                    resultsfound = True
                    continue
                elif t == 'MATCH RESULTS':
                    resultsfound = True
                    continue
                elif t == 'SECTION RESULTS':
                    resultsfound = True
                    continue
                else:
                    continue
                if pinfound and namefound:
                    self.players[pin] = (name, bcfcode)
                    self.results[pin] = []
                    pinfound = False
                    namefound = False
            elif not finishfound:
                if t == 'PIN1':
                    pin1found = True
                    pin1 = e[-1]
                elif t == 'PIN2':
                    pin2found = True
                    pin2 = e[-1]
                elif t == 'SCORE':
                    scorefound = True
                    score = e[-1]
                elif t == 'FINISH':
                    finishfound = True
                    continue
                else:
                    continue
                if pin1found and pin2found and scorefound:
                    self.results[pin1].append((pin2, score[0]))
                    self.results[pin2].append((pin1, score[-1]))
                    pin1found = False
                    pin2found = False
                    scorefound = False


if __name__ == '__main__':

    from os.path import abspath

    a = Event(abspath('results/Results 2005-2006/RMCCC902.TXT'))
    print a.file
    for p in a.players:
        print p, a.players[p], a.results[p]
